local _, ns = ...
local WK = ns.WhoKnows
local debugPrint = WK.debugPrint
WK.InventoryFrames = {}
-------------------------------------------------------

-- credit to Trond A Ekseth <troeks@gmail.com> of oGlow addon for quick copypasta of container code
-- check it out @ http://www.wowinterface.com/downloads/info7142-oGlow.html
-----------------------------------------------------------------------------
function WK.InventoryFrames.LoadItemGlows()
	local addOnEnabled = WhoKnows_Data.enableAddon
	WK.InventoryFrames.BagScanEnable(addOnEnabled and WhoKnows_Data.ScanEnableBag)
	WK.InventoryFrames.GuildBankScanEnable(addOnEnabled and WhoKnows_Data.ScanEnableGuildBank)
	WK.InventoryFrames.BankScanEnable(addOnEnabled and WhoKnows_Data.ScanEnableBank)
	WK.InventoryFrames.LootEnable(addOnEnabled and WhoKnows_Data.ScanEnableLoot)
	WK.InventoryFrames.MerchantScanEnable(addOnEnabled and WhoKnows_Data.ScanEnableVendors)
	WK.InventoryFrames.AuctionScanEnable(addOnEnabled and WhoKnows_Data.ScanEnableAH)
	WK.InventoryFrames.MailboxScanEnable(addOnEnabled and WhoKnows_Data.ScanEnableMailbox)
end

--TODO: needed?
--WK.InventoryFrames.Openframes = {}

-------------------------------------------------------------------------------------
-- Bags
-------------------------------------------------------------------------------------
local BagScanUpdate = function(self)
	if not WK.InventoryFrames.BagScan_E then return end
	local id = self:GetID()
	local name = self:GetName()
	local size = self.size
	for i = 1, size do
		local bid = size - i + 1
		local slotFrame = _G[name .. 'Item' .. bid]
		local slotLink = GetContainerItemLink(id, i)
		if WK.IsLearnableItem(slotLink) then
			WK.ItemGlow:OverlaySetup(slotFrame, slotLink)
			--WK.Itemcache:Add(WK.GetItemIdFromHyperlink(slotLink))
		else WK.ItemGlow:Overlay_Hide(slotFrame)
		end
	end
end

function WK.InventoryFrames.BagScanEnable(enable)
	if (enable == true) then
		WK.InventoryFrames.BagScan_E = true
		if (not WK.InventoryFrames.BagScanHook) then
			hooksecurefunc("ContainerFrame_Update", BagScanUpdate)
			WK.InventoryFrames.BagScanHook = true
		end
	else
		WK.InventoryFrames.BagScan_E = nil
		WK.WKEvFrame:UnregisterEvent('BAG_OPEN')
	end
end

-------------------------------------------------------------------------------------
-- Guild Bank
-------------------------------------------------------------------------------------
function WK.InventoryFrames.GuildBankScanUpdate()
	--if (not IsAddOnLoaded "Blizzard_GuildBankUI") then return end

	local tab = GetCurrentGuildBankTab()
	for i = 1, MAX_GUILDBANK_SLOTS_PER_TAB or 98 do
		local index = math.fmod(i, 14)
		if (index == 0) then
			index = 14
		end
		local column = math.ceil((i - 0.5) / 14)

		local slotLink = GetGuildBankItemLink(tab, i)
		local slotFrame = _G["GuildBankColumn" .. column .. "Button" .. index]

		if WK.IsLearnableItem(slotLink) then
			WK.ItemGlow:OverlaySetup(slotFrame, slotLink)
		else WK.ItemGlow:Overlay_Hide(slotFrame)
		end
	end
end

function WK.InventoryFrames.GuildBankScanEnable(enable)
	if (enable == true) then
		WK.WKEvFrame:RegisterEvent('GUILDBANKBAGSLOTS_CHANGED')
		WK.WKEvFrame:RegisterEvent('GUILDBANKFRAME_OPENED')
	else
		WK.WKEvFrame:UnregisterEvent('GUILDBANKBAGSLOTS_CHANGED')
		WK.WKEvFrame:UnregisterEvent('GUILDBANKFRAME_OPENED')
	end
end

------------------------------------------------------------------------------------
-- Bank
-------------------------------------------------------------------------------------
function WK.InventoryFrames.BankScanUpdate()
	if (BankFrame:IsShown()) then
		for i = 1, NUM_BANKGENERIC_SLOTS or 28 do
			local slotFrame = _G['BankFrameItem' .. i]
			local itemLink = GetContainerItemLink(-1, i)

			if WK.IsLearnableItem(itemLink) then
				WK.ItemGlow:OverlaySetup(slotFrame, itemLink)
			else WK.ItemGlow:Overlay_Hide(slotFrame)
			end
		end
	end
end

function WK.InventoryFrames.BankScanEnable(enable)
	if (enable == true) then
		WK.WKEvFrame:RegisterEvent('BANKFRAME_OPENED')
		WK.WKEvFrame:RegisterEvent('PLAYERBANKSLOTS_CHANGED')
	else
		WK.WKEvFrame:UnregisterEvent('BANKFRAME_OPENED')
		WK.WKEvFrame:UnregisterEvent('PLAYERBANKSLOTS_CHANGED')
	end
end

-------------------------------------------------------------------------------------
-- Loot Frame
-------------------------------------------------------------------------------------
function WK.InventoryFrames.LootUpdate()
	if (WK.InventoryFrames.Loot_E and LootFrame:IsShown()) then
		for i = 1, LOOTFRAME_NUMBUTTONS or 4 do
			local slotFrame = _G['LootButton' .. i]
			local slot = slotFrame.slot
			local itemLink
			if (slot) then
				itemLink = GetLootSlotLink(slot)
			end
			if WK.IsLearnableItem(itemLink) then
				WK.ItemGlow:OverlaySetup(slotFrame, itemLink)
			else WK.ItemGlow:Overlay_Hide(slotFrame)
			end
		end
	end
end

function WK.InventoryFrames.LootEnable(enable)
	if (enable == true) then
		WK.InventoryFrames.Loot_E = true
		if (not WK.InventoryFrames.LootHook) then
			LootFrameUpButton:HookScript("OnClick", WK.InventoryFrames.LootUpdate)
			LootFrameDownButton:HookScript("OnClick", WK.InventoryFrames.LootUpdate)
			WK.InventoryFrames.LootHook = true
		end
		WK.WKEvFrame:RegisterEvent('LOOT_OPENED')
		WK.WKEvFrame:RegisterEvent('LOOT_SLOT_CLEARED')
		WK.WKEvFrame:RegisterEvent('LOOT_SLOT_CHANGED')
	else
		WK.InventoryFrames.Loot_E = nil
		WK.WKEvFrame:UnregisterEvent('LOOT_OPENED')
		WK.WKEvFrame:UnregisterEvent('LOOT_SLOT_CLEARED')
		WK.WKEvFrame:UnregisterEvent('LOOT_SLOT_CHANGED')
	end
end

-------------------------------------------------------------------------------------
-- Merchants
-------------------------------------------------------------------------------------
function WK.InventoryFrames.MerchantScanUpdate()
	if (WK.InventoryFrames.MerchantScan_E) then --MerchantFrame:IsShown()
	if (MerchantFrame.selectedTab == 1) then -- tab 1 = items to buy, tab 2 = buy back items
	for i = 1, MERCHANT_ITEMS_PER_PAGE do
		local index = (((MerchantFrame.page - 1) * MERCHANT_ITEMS_PER_PAGE) + i)
		local itemLink = GetMerchantItemLink(index)
		local slotFrame = _G['MerchantItem' .. i .. 'ItemButton']
		if WK.IsLearnableItem(itemLink) then
			local isNotLearnable = not select(6, GetMerchantItemInfo(index))
			WK.ItemGlow:OverlaySetup(slotFrame, itemLink, (isNotLearnable and true or false))
		else
			WK.ItemGlow:Overlay_Hide(slotFrame)
		end
	end

	local buyBackLink = GetBuybackItemLink(GetNumBuybackItems())
	if WK.IsLearnableItem(buyBackLink) then
		WK.ItemGlow:OverlaySetup(MerchantBuyBackItemItemButton, buyBackLink)
	else
		WK.ItemGlow:Overlay_Hide(MerchantBuyBackItemItemButton)
	end
	else
		for i = 1, BUYBACK_ITEMS_PER_PAGE do
			local itemLink = GetBuybackItemLink(i)
			local slotFrame = _G['MerchantItem' .. i .. 'ItemButton']
			if WK.IsLearnableItem(itemLink) then
				WK.ItemGlow:OverlaySetup(slotFrame, itemLink)
			else WK.ItemGlow:Overlay_Hide(slotFrame)
			end
		end
	end
	end
end

function WK.InventoryFrames.MerchantScanEnable(enable)
	if (enable == true) then
		WK.InventoryFrames.MerchantScan_E = true
		--			WK.WKEvFrame:RegisterEvent('MERCHANT_SHOW')
		if (not WK.InventoryFrames.MerchantScanHook) then
			hooksecurefunc('MerchantFrame_Update', WK.InventoryFrames.MerchantScanUpdate)
			WK.InventoryFrames.MerchantScanHook = true
		end
	else
		WK.InventoryFrames.MerchantScan_E = nil
		--			WK.WKEvFrame:UnregisterEvent('MERCHANT_SHOW')
	end
end

-------------------------------------------------------------------------------------
-- Auctions
-------------------------------------------------------------------------------------

NUM_BROWSE_TO_DISPLAY = NUM_BROWSE_TO_DISPLAY or 8
NUM_AUCTION_ITEMS_PER_PAGE = NUM_AUCTION_ITEMS_PER_PAGE or 50
--[[
function WK.InventoryFrames:AuctionScanUpdate()
	if not WK.InventoryFrames.auctionHook_E or not AuctionFrameBrowse:IsVisible() then return end
	local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
	for i=1, NUM_BROWSE_TO_DISPLAY do
        index = offset + i + (NUM_AUCTION_ITEMS_PER_PAGE * AuctionFrameBrowse.page);
        button = _G["BrowseButton"..i.."Item"];
		local itemLink = GetAuctionItemLink("list", offset + i)

		if WK.IsLearnableItem(itemLink) then
			 WK.ItemGlow:OverlaySetup(button, itemLink)
		else
			 WK.ItemGlow:Overlay_Hide(button)
		end
	end
end
]] --


local AuctionFrameItems = function(frameName, btnName, listType)
	if not WK.InventoryFrames.auctionHook_E and _G["AuctionFrame"]:IsShown() == false then return end
	local numItems = GetNumAuctionItems(listType)
	local offset = FauxScrollFrame_GetOffset(_G[frameName])
	if not offset then debugPrint("no offset : " .. frameName); return; end
	for i = 1, NUM_BROWSE_TO_DISPLAY do
		local index = offset + i
		if (index > numItems) then
			return
		end

		local iconTexture = _G[btnName .. i .. "ItemIconTexture"];
		--rare bug where iconTexture is null so test for it
		if iconTexture then iconTexture:SetVertexColor(1.0, 1.0, 1.0) end

		local itemLink = GetAuctionItemLink(listType, index)
		local button = _G[btnName .. i .. "Item"]
		if WK.IsLearnableItem(itemLink) then
			WK.ItemGlow:OverlaySetup(button, itemLink)
		else
			WK.ItemGlow:Overlay_Hide(button)
		end
	end
end

local AuctionBrowseFrame = function()
	if not AuctionFrameBrowse:IsVisible() then return end
	AuctionFrameItems("BrowseScrollFrame", "BrowseButton", "list")
end
local AuctionBidFrame = function()
	if not AuctionFrameBid:IsVisible() then return end
	AuctionFrameItems("BidScrollFrame", "BidButton", "bidder")
end
local AuctionOwnerFrame = function()
	if not AuctionFrameAuctions:IsVisible() then return end
	AuctionFrameItems("AuctionsScrollFrame", "AuctionsButton", "owner")
end

function WK.InventoryFrames.AuctionScanEnable(enable)
	if (enable) and IsAddOnLoaded('Blizzard_AuctionUI') then
		debugPrint("Enable auction scan")
		WK.InventoryFrames.auctionHook_E = true
		if not WK.InventoryFrames.auctionHook then
			hooksecurefunc('AuctionFrameBrowse_Update', AuctionBrowseFrame)
			hooksecurefunc('AuctionFrameBid_Update', AuctionBidFrame)
			hooksecurefunc('AuctionFrameAuctions_Update', AuctionOwnerFrame)
			WK.InventoryFrames.auctionHook = true
		end
		--	WK.WKEvFrame:RegisterEvent('AUCTION_HOUSE_SHOW')
		--	WK.WKEvFrame:RegisterEvent('AUCTION_ITEM_LIST_UPDATE')
		-- else
		--	WK.WKEvFrame:UnregisterEvent('AUCTION_HOUSE_SHOW')
		--	WK.WKEvFrame:UnregisterEvent('AUCTION_ITEM_LIST_UPDATE')
		WK.InventoryFrames.auctionHook_E = nil
	end
end

-------------------------------------------------------------------------------------
-- Mailbox
-------------------------------------------------------------------------------------
function WK.InventoryFrames.ProcessSendMailbox()
	if (not SendMailFrame:IsShown()) then return end

	for i = 1, ATTACHMENTS_MAX_SEND do
		local slotLink = GetSendMailItemLink(i)
		local slotFrame = _G["SendMailAttachment" .. i]
		if WK.IsLearnableItem(slotLink) then
			WK.ItemGlow:OverlaySetup(slotFrame, slotLink)
		else WK.ItemGlow:Overlay_Hide(slotFrame)
		end
	end
end

local inbox = function()
	local numItems = GetInboxNumItems()
	local index = ((InboxFrame.pageNum - 1) * INBOXITEMS_TO_DISPLAY) + 1
	for i = 1, INBOXITEMS_TO_DISPLAY do
		local slotFrame = _G["MailItem" .. i .. "Button"]
		if (index <= numItems) then
			for j = 1, ATTACHMENTS_MAX_RECEIVE do
				local attachLink = GetInboxItemLink(index, j)
				if (attachLink and WK.IsLearnableItem(attachLink)) then
					WK.ItemGlow:OverlaySetup(slotFrame, attachLink)
				else WK.ItemGlow:Overlay_Hide(slotFrame)
				end
			end
		end
		index = index + 1
	end
end
local letter = function()
	if (not InboxFrame.openMailID) then return end
	for i = 1, ATTACHMENTS_MAX_RECEIVE do
		local itemLink = GetInboxItemLink(InboxFrame.openMailID, i)
		if (itemLink) then
			local slotFrame = _G["OpenMailAttachmentButton" .. i]
			if WK.IsLearnableItem(itemLink) then
				WK.ItemGlow:OverlaySetup(slotFrame, itemLink)
			else WK.ItemGlow:Overlay_Hide(slotFrame)
			end
		end
	end
end

local hookLetter = function(...)
	if (WhoKnows_Data.ScanEnableMailbox == true) then letter(...) end
end

local hookInbox = function(...)
	if (WhoKnows_Data.ScanEnableMailbox == true) then inbox(...) end
end

function WK.InventoryFrames.MailboxScanEnable(enable)
	if (enable == true) then
		WK.WKEvFrame:RegisterEvent('MAIL_SHOW')
		WK.WKEvFrame:RegisterEvent('MAIL_SEND_INFO_UPDATE')
		WK.WKEvFrame:RegisterEvent('MAIL_SEND_SUCCESS')
		if (not WK.InventoryFrames.mailboxHook) then
			hooksecurefunc("OpenMail_Update", hookLetter)
			hooksecurefunc("InboxFrame_Update", hookInbox)
			WK.InventoryFrames.mailboxHook = true
		end
	else
		WK.WKEvFrame:UnregisterEvent('MAIL_SHOW')
		WK.WKEvFrame:UnregisterEvent('MAIL_SEND_INFO_UPDATE')
		WK.WKEvFrame:UnregisterEvent('MAIL_SEND_SUCCESS')
	end
end
